#include<Adafruit_NeoPixel.h>
#include<ESP8266WiFi.h>
#include<ESP8266WebServer.h>


#define NUM_LEDS 11
#define DATA_PIN D3
#define sensor A0
#define green 1
#define red 2
#define IN1 14 //GPIO 14
#define IN2 12 //GPIO 12
#define IN3 13 //GPIO 13
#define IN4 15 //GPIO 15

Adafruit_NeoPixel pixels(NUM_LEDS, DATA_PIN, NEO_GRB + NEO_KHZ800);

ESP8266WebServer server(80);


boolean triggered();
void setStrip(int cor);
const int NBSTEPS = 4095;
const int STEPTIME = 900;
int Step = 0;
boolean Clockwise = true;

int arrayDefault[4] = {LOW, LOW, LOW, LOW};

int stepsMatrix[8][4] = {
  {LOW, LOW, LOW, HIGH},
  {LOW, LOW, HIGH, HIGH},
  {LOW, LOW, HIGH, LOW},
  {LOW, HIGH, HIGH, LOW},
  {LOW, HIGH, LOW, LOW},
  {HIGH, HIGH, LOW, LOW},
  {HIGH, LOW, LOW, LOW},
  {HIGH, LOW, LOW, HIGH},
};

unsigned long lastTime = 0L;
unsigned long times = 0L;

void writeStep(int outArray[4]);
void stepper();
void setDirection();
void motion();
void handleRoot();
void cmd1();



void setup() {
  Serial.begin(115200);
  pixels.begin();
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
}

void loop() {
  if(triggered()==true){
    setStrip(green);
    motion(4);
  }
  else{
    setStrip(red);
  }
  //delay(1000);
}

boolean triggered(){
  int readout=analogRead(sensor);
  if(readout >=600){
    return true;
  }
  else
  {
    return false;
  }
}

void setStrip(int cor){
  if (cor==green){
    for(int i=0;i<NUM_LEDS;i++){
      pixels.setPixelColor(i, pixels.Color(0,150,0));
    }
    pixels.show();
  }
  else if (cor==red){
    for(int i=0;i<NUM_LEDS;i++){
      pixels.setPixelColor(i, pixels.Color(150,0,0));
    }
    pixels.show();
  }
}
void writeStep(int outArray[4]) {
  digitalWrite(IN1, outArray[0]);
  digitalWrite(IN2, outArray[1]);
  digitalWrite(IN3, outArray[2]);
  digitalWrite(IN4, outArray[3]);
}

void stepper() {
  if ((Step >= 0) && (Step < 8)) {
    writeStep(stepsMatrix[Step]);
  } else {
    writeStep(arrayDefault);
  }
  setDirection();
}

void setDirection() {
  (Clockwise == true) ? (Step++) : (Step--);

  if (Step > 7) {
    Step = 0;
  } else if (Step < 0) {
    Step = 7;
  }
}

void motion(int duration){
  unsigned long currentMicros;
  int cycle = 0;
  int stepsLeft = NBSTEPS;
  times = 0;
  lastTime = micros();
  for ( cycle =0;cycle<=duration;cycle++){
  while (stepsLeft > 0) {
    currentMicros = micros();
    if (currentMicros - lastTime >= STEPTIME) {
      stepper();
      times += micros() - lastTime;
      lastTime = micros();
      stepsLeft--;
    }
    delay(1);
  }
  }
  //delay(2000);
  //Clockwise = !Clockwise;
  stepsLeft = NBSTEPS;
}
